#include <vcl.h>
#pragma hdrstop

#include "draw.h"


//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOpenGL_Form *OpenGL_Form;
//---------------------------------------------------------------------------
__fastcall TOpenGL_Form::TOpenGL_Form(TComponent* Owner)
	: TForm(Owner)
{
 VisibleTime = 20; //      100 
 Data        = NULL;
 PointsNUM   = 0;
}
//---------------------------------------------------------------------------
void __fastcall TOpenGL_Form::Timer1Timer(TObject *Sender)
{
  Timer1->Enabled = false;
  DrawScene();
  Yield();
  Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
BOOL bSetupPixelFormat(HDC hdc)
{
  PIXELFORMATDESCRIPTOR pfd, *ppfd;
  int pixelformat;

  ppfd = &pfd;

  ppfd->nSize    = sizeof(PIXELFORMATDESCRIPTOR);
  ppfd->nVersion = 1;
  ppfd->dwFlags  = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL |
                   PFD_DOUBLEBUFFER;
  ppfd->dwLayerMask  = PFD_MAIN_PLANE;
  ppfd->iPixelType   = PFD_TYPE_COLORINDEX;
  ppfd->cColorBits   = 8;
  ppfd->cDepthBits   = 16;

  ppfd->cAccumBits   = 0;
  ppfd->cStencilBits = 0;

  if ( (pixelformat = ChoosePixelFormat(hdc, ppfd)) == 0 )
    {
     MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK);
     return FALSE;
    }

  if (SetPixelFormat(hdc, pixelformat, ppfd) == FALSE)
    {
     MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK);
     return FALSE;
    }

  return TRUE;
}
//---------------------------------------------------------------------------
void	TOpenGL_Form::DrawScene()
{
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

    glLoadIdentity();
    glTranslatef(0.0,0.0,-1.0);
    glBegin(GL_LINE_STRIP);
        for(int i = 0; i<PointsNUM; i++)
           {
            glVertex2f(Data[i].x,Data[i].y);
           }
    glEnd();
    glFlush();
    SwapBuffers(ghDC);
}
//---------------------------------------------------------------------------
GLvoid TOpenGL_Form::resize(GLsizei width, GLsizei height)
{
    glViewport(0, 0, width, height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0.0, width, 0.0, height);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}
//---------------------------------------------------------------------------
GLvoid TOpenGL_Form::initializeGL(GLsizei width, GLsizei height)
{
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0);
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
}
//---------------------------------------------------------------------------
void __fastcall TOpenGL_Form::FormCreate(TObject *Sender)
{
  ghDC = GetDC(DrawPanel->Handle);
  if (!bSetupPixelFormat(ghDC)) Close();
  ghRC = wglCreateContext(ghDC);
  wglMakeCurrent(ghDC, ghRC);
  initializeGL(DrawPanel->Width, DrawPanel->Height);

  resize(DrawPanel->Width, DrawPanel->Height);
}
//---------------------------------------------------------------------------
void __fastcall TOpenGL_Form::FormClose(TObject *Sender, TCloseAction &Action)
{
  Timer1->Enabled = false;
  if (ghRC) wglDeleteContext(ghRC);
  if (ghDC) ReleaseDC(Handle, ghDC);
}
//---------------------------------------------------------------------------
void __fastcall TOpenGL_Form::DrawPanelResize(TObject *Sender)
{
 resize(DrawPanel->Width, DrawPanel->Height);
}
//---------------------------------------------------------------------------
void __fastcall TOpenGL_Form::FormDestroy(TObject *Sender)
{
 delete[] Data;
}
//---------------------------------------------------------------------------
void TOpenGL_Form::AddData()
{
 int i = 0;
 if(Data!=NULL)
    {
     CPoint *tmpData = new CPoint[PointsNUM];
     for(i = 0; i<PointsNUM; i++)
        {
         tmpData[i].x = Data[i].x;
         tmpData[i].y = Data[i].y;
        }
     delete [] Data;

     PointsNUM+=1;
     Data = new CPoint[PointsNUM];
     for(i = 0; i<PointsNUM-1; i++)
        {
         Data[i].x = tmpData[i].x;
         Data[i].y = tmpData[i].y;
        }
     delete [] tmpData;
    }
    else
        {
         PointsNUM = 1;
         Data = new CPoint[PointsNUM];
        }
 time_t cur_time;
 time(&cur_time);
 Data[PointsNUM-1].x = (cur_time - beginTime)*DrawPanel->Width/VisibleTime;
 Data[PointsNUM-1].y = random(DrawPanel->Height);
}
void __fastcall TOpenGL_Form::Button1Click(TObject *Sender)
{
 Timer2->Enabled = !Timer2->Enabled;
 if(Timer2->Enabled)
   {
    time(&beginTime);
    randomize();
   }
   else
      {
       if (Data)
          {
           PointsNUM = 0;
           delete [] Data;
           Data = NULL;
          } 
      }
}
//---------------------------------------------------------------------------

void __fastcall TOpenGL_Form::Timer2Timer(TObject *Sender)
{
 time_t cur_time;
 time(&cur_time);
 if (cur_time - beginTime >= VisibleTime)
    {

     PointsNUM = 0;
     delete [] Data;
     Data = NULL;
     time(&beginTime);
     randomize();
    }
    else  AddData();
}
//---------------------------------------------------------------------------

